/**
 * @author Aleksandar Dragojevic aleksandar.dragojevic@epfl.ch
 */

#include "transaction_mixinv.h"

#ifdef MY_SCHEME
pthread_mutex_t wlpdstm::TxMixinv::queue_lock;
int wlpdstm::TxMixinv::queue_length;

//int wlpdstm::TxMixinv::thread_estimate;
#endif

#ifdef POOL_SCHEME
pthread_mutex_t wlpdstm::TxMixinv::queue_lock;

#ifdef MEASURE_QUEUEING
int wlpdstm::TxMixinv::queue_length;
int wlpdstm::TxMixinv::my_thread_count;
int wlpdstm::TxMixinv::number;
#endif


#endif

#ifdef YOO_SCHEME
wlpdstm::ATSScheduler * wlpdstm::TxMixinv::sch;
pthread_t * wlpdstm::TxMixinv::sch_thread;
int wlpdstm::TxMixinv::yoo_count;
#endif

#ifdef CAR_SCHEME
volatile unsigned long wlpdstm::TxMixinv::timeCounter;
#endif

wlpdstm::VersionLock wlpdstm::TxMixinv::version_lock_table[FULL_VERSION_LOCK_TABLE_SIZE];

CACHE_LINE_ALIGNED wlpdstm::GlobalTimestamp wlpdstm::TxMixinv::commit_ts;

CACHE_LINE_ALIGNED wlpdstm::GlobalTimestamp wlpdstm::TxMixinv::cm_ts;

CACHE_LINE_ALIGNED wlpdstm::PaddedUnsigned wlpdstm::TxMixinv::minimum_observed_ts;

CACHE_LINE_ALIGNED wlpdstm::PaddedSpinTryLock wlpdstm::TxMixinv::minimum_observed_ts_lock;

wlpdstm::TxMixinv *wlpdstm::TxMixinv::transactions[MAX_THREADS];

unsigned wlpdstm::TxMixinv::thread_count;

CACHE_LINE_ALIGNED wlpdstm::PaddedBool wlpdstm::TxMixinv::synchronization_in_progress;

#ifdef ADAPTIVE_LOCKING
CACHE_LINE_ALIGNED wlpdstm::PaddedUnsigned wlpdstm::TxMixinv::lock_extent;

unsigned wlpdstm::TxMixinv::false_sharing_history[FALSE_SHARING_HISTORY_SIZE];
#endif /* ADAPTIVE_LOCKING */
